<?php
namespace FiloBlu\ScratchAndWin\Controller\Adminhtml\ScratchAndWinDetails;

use Magento\Backend\App\Action;

class Delete extends \Magento\Backend\App\Action
{

    protected $scratchAndWinDetails;

    protected $scratchAndWinDetailsTranslations;

    public function __construct(
        Action\Context $context,
        \FiloBlu\ScratchAndWin\Model\ScratchAndWinDetailsFactory $scratchAndWinDetails,
        \FiloBlu\ScratchAndWin\Model\ScratchAndWinDetailsTranslationsFactory $scratchAndWinDetailsTranslations
    )
    {
        parent::__construct($context);
        $this->scratchAndWinDetails = $scratchAndWinDetails;
        $this->scratchAndWinDetailsTranslations = $scratchAndWinDetailsTranslations;
    }

    /**
     * {@inheritdoc}
     */
    protected function _isAllowed()
    {
        return $this->_authorization->isAllowed('FiloBlu_ScratchAndWin::config');
    }

    /**
     * Delete action
     *
     * @return \Magento\Framework\Controller\ResultInterface
     */
    public function execute()
    {
        $id = $this->getRequest()->getParam('id');
        $storeId = $this->getRequest()->getParam('store',0);

        $isSavingTranslation = false;

        if ($id && $storeId != 0) {
            $isSavingTranslation = true;
        }

        /** @var \Magento\Backend\Model\View\Result\Redirect $resultRedirect */
        $resultRedirect = $this->resultRedirectFactory->create();
        if ($id) {
            try {

                if ($isSavingTranslation) {
                    $model = $this->scratchAndWinDetailsTranslations->create();
                    $model->loadByParentAndStoreId($id,$storeId);
                }
                else {
                    $model = $this->scratchAndWinDetails->create();
                    $model->load($id);
                }

                $model->delete();
                $this->messageManager->addSuccess(__('The scratchandwin details has been deleted.'));

                if ($isSavingTranslation) {
                    return $resultRedirect->setPath('*/*/edit', ['id' => $id, 'store' => 0]);
                }
                else {
                    return $resultRedirect->setPath('*/*/');
                }

            } catch (\Exception $e) {
                $this->messageManager->addError($e->getMessage());
                return $resultRedirect->setPath('*/*/edit', ['id' => $id, 'store' => $storeId]);
            }
        }
        $this->messageManager->addError(__('We can\'t find a scratchandwin details to delete.'));
        return $resultRedirect->setPath('*/*/');
    }
}