<?php

namespace FiloBlu\ScratchAndWin\Helper;

class Data extends \Magento\Framework\App\Helper\AbstractHelper {

    protected $timezone;

    protected $storeManager;

    public function __construct(
        \Magento\Framework\App\Helper\Context $context,
        \Magento\Store\Model\StoreManagerInterface $storeManager
    ) {
        $this->scopeConfig = $context->getScopeConfig();
        $this->storeManager = $storeManager;
    }

    public function getConfig($config_path)
    {
        return $this->scopeConfig->getValue(
            $config_path,
            \Magento\Store\Model\ScopeInterface::SCOPE_STORE
        );
    }

    public function getCursor()
    {
        if ($this->getConfig('filoblu_scratchandwin_section/config/cursor_image')) {
            return $this->getConfig('filoblu_scratchandwin_section/config/cursor_image');
        }
    }

    public function getWebsiteId(){
        return $this->storeManager->getWebsite()->getId();
    }

    public function getBaseUrl()
    {
        return $this->storeManager->getStore()->getBaseUrl();
    }

    public function getScratchBaseUrl()
    {
        return $this->storeManager->getStore()->getBaseUrl(\Magento\Framework\UrlInterface::URL_TYPE_WEB, true);
    }

}
